<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: Accessory Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classAccessory.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classAccessory-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Accessory Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for Accessory:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classAccessory.png" usemap="#Accessory_map" alt=""/>
  <map id="Accessory_map" name="Accessory_map">
<area href="classAccessoryLight.html" alt="AccessoryLight" shape="rect" coords="0,56,160,80"/>
<area href="classAccessoryLightMulti.html" alt="AccessoryLightMulti" shape="rect" coords="170,56,330,80"/>
<area href="classAccessoryMotor.html" alt="AccessoryMotor" shape="rect" coords="340,56,500,80"/>
<area href="classAccessoryServo.html" alt="AccessoryServo" shape="rect" coords="510,56,670,80"/>
<area href="classAccessoryStepper.html" alt="AccessoryStepper" shape="rect" coords="680,56,840,80"/>
<area href="classAccessoryMotorOneWay.html" alt="AccessoryMotorOneWay" shape="rect" coords="255,112,415,136"/>
<area href="classAccessoryMotorTwoWays.html" alt="AccessoryMotorTwoWays" shape="rect" coords="425,112,585,136"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a64e6260a68ac84d94394a2076746f98a"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">Accessory</a> ()</td></tr>
<tr class="separator:a64e6260a68ac84d94394a2076746f98a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af94464d9b49e5700d3c20d0cd206ac51"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">begin</a> (ACC_STATE inStartingState = STATE_NONE)</td></tr>
<tr class="separator:af94464d9b49e5700d3c20d0cd206ac51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2883977d969dcde8f078934b4a9ed12"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPort.html">Port</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a> () const </td></tr>
<tr class="separator:ac2883977d969dcde8f078934b4a9ed12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b837b3afb75f5eadcde5e1742db5c7d"><td class="memItemLeft" align="right" valign="top">ACC_STATE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">GetState</a> () const </td></tr>
<tr class="separator:a6b837b3afb75f5eadcde5e1742db5c7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae26158a4fc16855e72706b317c40f9e8"><td class="memItemLeft" align="right" valign="top">ACC_STATE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ae26158a4fc16855e72706b317c40f9e8">GetPreviousState</a> () const </td></tr>
<tr class="separator:ae26158a4fc16855e72706b317c40f9e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69732e492455231abb564627cf66be7c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a69732e492455231abb564627cf66be7c">IsNone</a> () const </td></tr>
<tr class="separator:a69732e492455231abb564627cf66be7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05332408472b083ff1368172b79946be"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a05332408472b083ff1368172b79946be">IsFirst</a> () const </td></tr>
<tr class="separator:a05332408472b083ff1368172b79946be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecdd43db80db0467109219f68d5fb7e4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#aecdd43db80db0467109219f68d5fb7e4">IsSecond</a> () const </td></tr>
<tr class="separator:aecdd43db80db0467109219f68d5fb7e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57d1cb4de69eb625fc2bb82788591a22"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">AddMovingPosition</a> (unsigned long inId, int inPosition)</td></tr>
<tr class="separator:a57d1cb4de69eb625fc2bb82788591a22"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac818b7112183d3d65ec361c8402f927f"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">GetDebounceDelay</a> () const </td></tr>
<tr class="separator:ac818b7112183d3d65ec361c8402f927f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a933cd0907dc257b1f1047c33d41ceb2a"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">GetLastMoveTime</a> () const </td></tr>
<tr class="separator:a933cd0907dc257b1f1047c33d41ceb2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cfe1c1ca32753832146656755f6e7a7"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a> () const </td></tr>
<tr class="separator:a8cfe1c1ca32753832146656755f6e7a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5891e60944d8542a8bd1eb8862e5010e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">loop</a> ()</td></tr>
<tr class="separator:a5891e60944d8542a8bd1eb8862e5010e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f4a8cacc38e0bac6e83ed5a136073e0"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">Event</a> (unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</td></tr>
<tr class="separator:a6f4a8cacc38e0bac6e83ed5a136073e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49f289549f486e8307ec06123939ca40"><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a49f289549f486e8307ec06123939ca40">EEPROMSave</a> (int inPos, bool inSimulate = false)</td></tr>
<tr class="separator:a49f289549f486e8307ec06123939ca40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a245ad3bad4fa0f1d657fdc20b2edb868"><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">EEPROMLoad</a> (int inPos)</td></tr>
<tr class="separator:a245ad3bad4fa0f1d657fdc20b2edb868"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd67b5953eb1b55a52a87a779574e3b6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">AdjustMovingPositionsSize</a> (uint8_t inNewSize)</td></tr>
<tr class="separator:acd67b5953eb1b55a52a87a779574e3b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac89f301db7c889f32aa8ab5534592975"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ac89f301db7c889f32aa8ab5534592975">IsEmpty</a> () const </td></tr>
<tr class="separator:ac89f301db7c889f32aa8ab5534592975"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a224977dffaa54df56def6a7b15af0031"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a> (unsigned long inId) const </td></tr>
<tr class="separator:a224977dffaa54df56def6a7b15af0031"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa249535a3c36291764e38ab1e4ae4cee"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">GetMovingPosition</a> (unsigned long inId) const </td></tr>
<tr class="separator:aa249535a3c36291764e38ab1e4ae4cee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62eee418f630f805d36f6005e0db1a9e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">GetMovingPositionByIndex</a> (int inIndex) const </td></tr>
<tr class="separator:a62eee418f630f805d36f6005e0db1a9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f0410f39fa692494b51bc880714bdd1"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">GetMovingPositionIdByIndex</a> (int inIndex) const </td></tr>
<tr class="separator:a4f0410f39fa692494b51bc880714bdd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a292f4e066803d0f6f32a953216443c9d"><td class="memItemLeft" align="right" valign="top">const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">GetLastMovingPosition</a> () const </td></tr>
<tr class="separator:a292f4e066803d0f6f32a953216443c9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4dc998e8f09ac7f94a3e06c56e8d5d4"><td class="memItemLeft" align="right" valign="top">const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a> () const </td></tr>
<tr class="separator:ac4dc998e8f09ac7f94a3e06c56e8d5d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e837b6c4251c2fe69066d3146dd8478"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a> (uint8_t inLastPositionIndex)</td></tr>
<tr class="separator:a5e837b6c4251c2fe69066d3146dd8478"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83da11bad71b628431ac86cc1cbaf60c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a83da11bad71b628431ac86cc1cbaf60c">SetDebounceDelay</a> (unsigned int inDebounceDelay)</td></tr>
<tr class="separator:a83da11bad71b628431ac86cc1cbaf60c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4a38203fce08f72755835ff126bddb0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">SetLastMoveTime</a> ()</td></tr>
<tr class="separator:af4a38203fce08f72755835ff126bddb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e68b4693371383dfb026869af30d1d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">SetDuration</a> (unsigned long inDuration)</td></tr>
<tr class="separator:a6e68b4693371383dfb026869af30d1d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d8deba14ebc355146c2ff26b4e4669c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">SetNextAccessory</a> (Accessory *inAccessory)</td></tr>
<tr class="separator:a1d8deba14ebc355146c2ff26b4e4669c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa27a04b9e2a95729e491598cb34c6e47"><td class="memItemLeft" align="right" valign="top">Accessory *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a> () const </td></tr>
<tr class="separator:aa27a04b9e2a95729e491598cb34c6e47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a9a9e26544b859289f125dd075cf52e"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">GetActionStartingMillis</a> () const </td></tr>
<tr class="separator:a8a9a9e26544b859289f125dd075cf52e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1dad31ee3bcac4b1baf9a140c7fa57d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a> ()</td></tr>
<tr class="separator:ab1dad31ee3bcac4b1baf9a140c7fa57d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a3c9f8604297fcb55141a720169fd90"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a9a3c9f8604297fcb55141a720169fd90">StartAction</a> (ACC_STATE inState)</td></tr>
<tr class="separator:a9a3c9f8604297fcb55141a720169fd90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3de65543a892b3418df72f54439605cb"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a> ()</td></tr>
<tr class="separator:a3de65543a892b3418df72f54439605cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af693b11f2a3b1a7c93d7fa43e600f292"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">ActionEnded</a> ()</td></tr>
<tr class="separator:af693b11f2a3b1a7c93d7fa43e600f292"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8c3ad3e37a2ba5914f419abd3e2426f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a> () const </td></tr>
<tr class="separator:ae8c3ad3e37a2ba5914f419abd3e2426f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef81e617d15f62090ccce7eee4f0d3c3"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">IsGroupActionPending</a> () const </td></tr>
<tr class="separator:aef81e617d15f62090ccce7eee4f0d3c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ab6995aadf87dd3f7edf1d2f448ab85"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a2ab6995aadf87dd3f7edf1d2f448ab85">Move</a> (unsigned long inMovingPositionId) = 0</td></tr>
<tr class="separator:a2ab6995aadf87dd3f7edf1d2f448ab85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f524a5ba6ba7f33e814e687c2912181"><td class="memItemLeft" align="right" valign="top">virtual ACC_STATE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Toggle</a> () = 0</td></tr>
<tr class="separator:a9f524a5ba6ba7f33e814e687c2912181"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a212359e11100e5ee9af5bd94a64d8823"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a212359e11100e5ee9af5bd94a64d8823">CanBePositional</a> () const </td></tr>
<tr class="separator:a212359e11100e5ee9af5bd94a64d8823"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3662f43014a6ec1f8719a687fe5c33ba"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a3662f43014a6ec1f8719a687fe5c33ba">MovePosition</a> (int inPosition)</td></tr>
<tr class="separator:a3662f43014a6ec1f8719a687fe5c33ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a408602468720dbf84c1e3d27cc0385da"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">SetState</a> (ACC_STATE inNewState)</td></tr>
<tr class="separator:a408602468720dbf84c1e3d27cc0385da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60e5e9122c96773c975fe9d2c2db6520"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a> (ACC_STATE inNewState)</td></tr>
<tr class="separator:a60e5e9122c96773c975fe9d2c2db6520"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5208f338b6ea9a5b5fd554c4e1ec60e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ac5208f338b6ea9a5b5fd554c4e1ec60e">SetStartingMillis</a> ()</td></tr>
<tr class="separator:ac5208f338b6ea9a5b5fd554c4e1ec60e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a882c7616f0433475d65e1ac5e8ecf616"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a882c7616f0433475d65e1ac5e8ecf616">ResetStartingMillis</a> ()</td></tr>
<tr class="separator:a882c7616f0433475d65e1ac5e8ecf616"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a6cf36c65d1519eb7e5a6aac1cba7fe51"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">ExecuteEvent</a> (unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</td></tr>
<tr class="separator:a6cf36c65d1519eb7e5a6aac1cba7fe51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8b0920b2a419e278fbc79e3fcc75f86"><td class="memItemLeft" align="right" valign="top">static uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">GetCount</a> ()</td></tr>
<tr class="separator:af8b0920b2a419e278fbc79e3fcc75f86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4efeb5b525027d5ccb692f0560a3474"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">IsActionPending</a> ()</td></tr>
<tr class="separator:ae4efeb5b525027d5ccb692f0560a3474"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab89d2b99293b24e6ccc38938384563f2"><td class="memItemLeft" align="right" valign="top">static Accessory *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">GetFirstAccessory</a> ()</td></tr>
<tr class="separator:ab89d2b99293b24e6ccc38938384563f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ae1ebffdf3fe753e3c5e7d05c2a61fd18"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPort.html">Port</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a></td></tr>
<tr class="separator:ae1ebffdf3fe753e3c5e7d05c2a61fd18"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7079494cf9cb5130e5b3a5762e04e947"><td class="memItemLeft" align="right" valign="top">ACC_STATE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a></td></tr>
<tr class="separator:a7079494cf9cb5130e5b3a5762e04e947"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This is the base class for all the accessories.</p>
<p>This class is a pure virtual class, so it cant be instanciated !</p>
<p>An accessory is a class driving a physical motor or light, receiving events to change its state. With each accessory is defined a port, giving power to the accessory. There is no accessory without port.</p>
<p>Each accessory have one or more <a class="el" href="structMovingPosition.html">MovingPosition</a>, with each one defined by an Id. Each accessory have also a current state, a current speed and can have a current position. All these states are saved in EEPROM at each state change, with a protection to avoid more than one saving by second.</p>
<p>The EEPROM area starting from EEPROMStart will be filled on EEPROMsize with the current version number (a byte), and the total number of accessories and groups. The fourth byte will be the checksum of the three starting bytes... If any of these four bytes are different from the actual values, the EEPROM will be considered as free. Two bytes are then added to store the size of one complete record, in order to be able to configurate the CircularBuffer.</p>
<p>Following these bytes, there is the CircularBuffer of accessories. For each one the current state, the current position and the current speed will be saved. After that, each group save its current item id.</p>
<pre class="fragment">+-+
Version                 |V|
Accessory number        |A|
Group number            |G|
header checksum         |C|
size byte 1             |s1]
size byte 2             |s2]
+-+
Circular buffer         | |
+-+
End of file.
</pre><p>And the Circular buffer is :</p>
<pre class="fragment">+-+
Acc 1 : State           |S|
Acc 1 : Position        |P|
Acc 1 : Speed           |s|
+-+
Acc 2 : State           |S|
Acc 2 : Position        |P|
Acc 2 : Speed           |s|
+-+
Acc 3 : State           |S|
Acc 3 : Position        |P|
Acc 3 : Speed           |s|
...                     +-+
Group 1 : current ID    |I|
Group 3 : current ID    |I|
Group 3 : current ID    |I|
+-+
End of record.
</pre> 
<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00140">140</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a64e6260a68ac84d94394a2076746f98a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Accessory::Accessory </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00015">15</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="af693b11f2a3b1a7c93d7fa43e600f292"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::ActionEnded </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Ends the current action of this accessory. </p><dl class="section return"><dt>Returns</dt><dd>true if the action is not finished. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p>Reimplemented in <a class="el" href="classAccessoryMotor.html#a7b07268c665e5ae1bc1bba6d215f185c">AccessoryMotor</a>.</p>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00134">134</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a57d1cb4de69eb625fc2bb82788591a22"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t Accessory::AddMovingPosition </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPosition</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add one moving position to the accessory. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inId</td><td>new Id </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">inPosition</td><td>Position for this id. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>index of the new position in the positions list. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>the total number of <a class="el" href="structMovingPosition.html">MovingPosition</a> must be set before with <a class="el" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">AdjustMovingPositionsSize()</a>. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00049">49</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="acd67b5953eb1b55a52a87a779574e3b6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::AdjustMovingPositionsSize </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inNewSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the number of <a class="el" href="structMovingPosition.html">MovingPosition</a>. If some <a class="el" href="structMovingPosition.html">MovingPosition</a> was previously existing, they will be preserved. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inNewSize</td><td>new size. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00029">29</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="af94464d9b49e5700d3c20d0cd206ac51"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::begin </td>
          <td>(</td>
          <td class="paramtype">ACC_STATE&#160;</td>
          <td class="paramname"><em>inStartingState</em> = <code>STATE_NONE</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Initialize the instance. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inStartingState</td><td>Starting state of the accessory. This is NOT an order to set the accessory in this state, only a way to take account of the current physical state of it ! </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00180">180</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a212359e11100e5ee9af5bd94a64d8823"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Accessory::CanBePositional </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if the accessory can be moved by an absolute value instead of a fix position. </p><dl class="section return"><dt>Returns</dt><dd>true if the accessory can be moved with move() function using an absolute value. </dd></dl>

<p>Reimplemented in <a class="el" href="classAccessoryServo.html#a508e4bd324b4784b1dbf3bc729906725">AccessoryServo</a>, and <a class="el" href="classAccessoryStepper.html#a7b735ebc78570e8ac043fcf84e7fafc1">AccessoryStepper</a>.</p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00419">419</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a245ad3bad4fa0f1d657fdc20b2edb868"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual int Accessory::EEPROMLoad </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPos</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Reload all data from the EEPROM. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p>Reimplemented in <a class="el" href="classAccessoryServo.html#a8e7338a290d34c194e7d351a8d4abaa5">AccessoryServo</a>, <a class="el" href="classAccessoryMotor.html#a62e7b93e8aa7c42795889e94882756b8">AccessoryMotor</a>, and <a class="el" href="classAccessoryLight.html#a0c90712da6035d00724928abe3a5eab2">AccessoryLight</a>.</p>

</div>
</div>
<a class="anchor" id="a49f289549f486e8307ec06123939ca40"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual int Accessory::EEPROMSave </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>inSimulate</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Save all the data in the EEPROM. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

</div>
</div>
<a class="anchor" id="a6f4a8cacc38e0bac6e83ed5a136073e0"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Accessory::Event </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ACCESSORIES_EVENT_TYPE&#160;</td>
          <td class="paramname"><em>inEvent</em> = <code>ACCESSORIES_EVENT_MOVEPOSITIONID</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inData</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Execute a new event. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>Id of an accessory or an accessory item. </td></tr>
    <tr><td class="paramname">inEvent</td><td>Type of the new event. Default is ACCESSORIES_EVENT_MOVEPOSITIONID. </td></tr>
    <tr><td class="paramname">inData</td><td>Associated data to the event type. Default is 0. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classAccessoryServo.html#a3fce38eaa89e64a11a18644fcd2d0fca">AccessoryServo</a>, <a class="el" href="classAccessoryLightMulti.html#ac4176e67ab3b73ba0e497f0afd8d37c9">AccessoryLightMulti</a>, <a class="el" href="classAccessoryMotor.html#af66799e4adf177e1a9b71b63225e74b1">AccessoryMotor</a>, <a class="el" href="classAccessoryLight.html#a9511861853b7de8f3b99ca43e49db16b">AccessoryLight</a>, and <a class="el" href="classAccessoryStepper.html#a0188ee79f43dcda4edce3fc16ee14bd6">AccessoryStepper</a>.</p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00266">266</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a6cf36c65d1519eb7e5a6aac1cba7fe51"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::ExecuteEvent </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ACCESSORIES_EVENT_TYPE&#160;</td>
          <td class="paramname"><em>inEvent</em> = <code>ACCESSORIES_EVENT_MOVEPOSITIONID</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inData</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Execute the event. </p>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00388">388</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a8a9a9e26544b859289f125dd075cf52e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long Accessory::GetActionStartingMillis </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the time of the starting of the current movement. </p><dl class="section return"><dt>Returns</dt><dd>starting time of the current movement. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00366">366</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="af8b0920b2a419e278fbc79e3fcc75f86"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t Accessory::GetCount </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the number of accessories. </p><dl class="section return"><dt>Returns</dt><dd>total number of accessories. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00233">233</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac818b7112183d3d65ec361c8402f927f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int Accessory::GetDebounceDelay </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the debounce delay of the accessory, when relevant. </p><dl class="section return"><dt>Returns</dt><dd>Previous debounce delay in milliseconds. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00243">243</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a8cfe1c1ca32753832146656755f6e7a7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long Accessory::GetDuration </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the duration. Some accessories needs a duration: blinking light, step for servo motor... </p><dl class="section return"><dt>Returns</dt><dd>duration for this accessory. 0 if no duration. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00254">254</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ab89d2b99293b24e6ccc38938384563f2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static Accessory* Accessory::GetFirstAccessory </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the first accessory address in the list. </p><dl class="section return"><dt>Returns</dt><dd>address of the first accessory in the list. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00355">355</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a933cd0907dc257b1f1047c33d41ceb2a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long Accessory::GetLastMoveTime </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the time of the last change of this accessory. A move can be done only if the elapsed time since last move is bigger than 'debounce' delay. </p><dl class="section return"><dt>Returns</dt><dd>last time of move in milliseconds. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00249">249</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a292f4e066803d0f6f32a953216443c9d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t Accessory::GetLastMovingPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the last position reached by this accessory. </p><dl class="section return"><dt>Returns</dt><dd>last position reached by the accessory, or 255 if it never moved. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00318">318</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aa249535a3c36291764e38ab1e4ae4cee"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Accessory::GetMovingPosition </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the position associated with the given Id. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>id of the <a class="el" href="structMovingPosition.html">MovingPosition</a> to find. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>position or UNDEFINED_POS if not found.. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00068">68</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a62eee418f630f805d36f6005e0db1a9e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int Accessory::GetMovingPositionByIndex </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inIndex</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the position at the given index of the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inIndex</td><td>index of the <a class="el" href="structMovingPosition.html">MovingPosition</a> in the list. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00307">307</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a4f0410f39fa692494b51bc880714bdd1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long Accessory::GetMovingPositionIdByIndex </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inIndex</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the id of the <a class="el" href="structMovingPosition.html">MovingPosition</a> at the given index of the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inIndex</td><td>index of the <a class="el" href="structMovingPosition.html">MovingPosition</a> in the list. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Id of this position. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00313">313</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac4dc998e8f09ac7f94a3e06c56e8d5d4"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t Accessory::GetMovingPositionSize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the number of <a class="el" href="structMovingPosition.html">MovingPosition</a>. </p><dl class="section return"><dt>Returns</dt><dd>Number of <a class="el" href="structMovingPosition.html">MovingPosition</a> set by <a class="el" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">AdjustMovingPositionsSize()</a>. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00323">323</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aa27a04b9e2a95729e491598cb34c6e47"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Accessory* Accessory::GetNextAccessory </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the next accessory in the list. </p><dl class="section return"><dt>Returns</dt><dd>address of the next accessory in the list. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00360">360</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac2883977d969dcde8f078934b4a9ed12"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPort.html">Port</a>* Accessory::GetPort </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the associated port. </p><dl class="section return"><dt>Returns</dt><dd>port address or NULL. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00185">185</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae26158a4fc16855e72706b317c40f9e8"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ACC_STATE Accessory::GetPreviousState </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the previous state of the accessory, when relevant. </p><dl class="section return"><dt>Returns</dt><dd>Previous state. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00215">215</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a6b837b3afb75f5eadcde5e1742db5c7d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ACC_STATE Accessory::GetState </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the current state of the accessory. </p><dl class="section return"><dt>Returns</dt><dd>current state. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00209">209</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a224977dffaa54df56def6a7b15af0031"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t Accessory::IndexOfMovingPosition </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Find the index of a <a class="el" href="structMovingPosition.html">MovingPosition</a> from its Id. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>id of the <a class="el" href="structMovingPosition.html">MovingPosition</a> to find. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>index of the found <a class="el" href="structMovingPosition.html">MovingPosition</a> or 255 if not found. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00059">59</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae8c3ad3e37a2ba5914f419abd3e2426f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsActionDelayPending </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if an action is still pending. </p><dl class="section return"><dt>Returns</dt><dd>true if an action is not ended. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00398">398</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae4efeb5b525027d5ccb692f0560a3474"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsActionPending </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if there is at least one accessory which needs more <a class="el" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">loop()</a> calls. </p><dl class="section return"><dt>Returns</dt><dd>true if one accessory needs more '<a class="el" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">loop()</a>'. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00260">260</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac89f301db7c889f32aa8ab5534592975"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsEmpty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if at least one <a class="el" href="structMovingPosition.html">MovingPosition</a> has been defined. </p><dl class="section return"><dt>Returns</dt><dd>true if there is at least one <a class="el" href="structMovingPosition.html">MovingPosition</a> defined. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00289">289</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a05332408472b083ff1368172b79946be"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsFirst </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if current state is STATE_FIRST. </p><dl class="section return"><dt>Returns</dt><dd>true if the current state is STATE_FIRST. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00225">225</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aef81e617d15f62090ccce7eee4f0d3c3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Accessory::IsGroupActionPending </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if an action is still pending on a group. </p><dl class="section return"><dt>Returns</dt><dd>true if an action is not ended or if all the items of the parent group have not been actioned. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00404">404</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a69732e492455231abb564627cf66be7c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsNone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if current state is STATE_NONE. </p><dl class="section return"><dt>Returns</dt><dd>true if the current state is STATE_NONE. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00220">220</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aecdd43db80db0467109219f68d5fb7e4"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::IsSecond </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if current state is STATE_SECOND. </p><dl class="section return"><dt>Returns</dt><dd>true if the current state is STATE_SECOND. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00230">230</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a5891e60944d8542a8bd1eb8862e5010e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Accessory::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop function. </p><dl class="section return"><dt>Returns</dt><dd>true if something has been done. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00259">259</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a2ab6995aadf87dd3f7edf1d2f448ab85"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Accessory::Move </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inMovingPositionId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Basic moving function. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inMovingPositionId</td><td>new position id from <a class="el" href="structMovingPosition.html">MovingPosition</a> to reach. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented <a class="el" href="classAccessoryServo.html#acb11e2c5c1b802c18fe5f146001a2baa">AccessoryServo</a>, <a class="el" href="classAccessoryMotor.html#a157b380119884b4895782c8a502cb310">AccessoryMotor</a>, and <a class="el" href="classAccessoryStepper.html#a83a36fe89064e4d5dc5e48b6e4c2d110">AccessoryStepper</a>.</p>

</div>
</div>
<a class="anchor" id="a3662f43014a6ec1f8719a687fe5c33ba"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Accessory::MovePosition </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inPosition</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Basic moving function for a positional motor. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inPosition</td><td>new position to reach. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>this function can be used only if <a class="el" href="classAccessory.html#a212359e11100e5ee9af5bd94a64d8823">CanBePositional()</a> returns true. </dd></dl>

<p>Reimplemented in <a class="el" href="classAccessoryServo.html#ad12214b347143b4b2dc9ae8c5aa42418">AccessoryServo</a>, and <a class="el" href="classAccessoryStepper.html#af4eee80dabc04e8cf26c543f095fe8ea">AccessoryStepper</a>.</p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00425">425</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a3de65543a892b3418df72f54439605cb"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Accessory::ResetAction </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Prepare for a future action </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00385">385</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a882c7616f0433475d65e1ac5e8ecf616"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::ResetStartingMillis </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Resets the starting time of the current action. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00446">446</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a83da11bad71b628431ac86cc1cbaf60c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetDebounceDelay </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>inDebounceDelay</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the debounce delay. This delay is used to be sure that the current move is finished. A new move will only operate if this delay is expired. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inDebounceDelay</td><td>delay needed to finish an action (movement...) of the accessory. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00334">334</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a6e68b4693371383dfb026869af30d1d2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetDuration </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inDuration</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets duration. This duration is used by lights for blinking, or by servos for the interval between elementary movements. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inDuration</td><td>duration of the accessory. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00344">344</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="af4a38203fce08f72755835ff126bddb0"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetLastMoveTime </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the last move time from the current time. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00339">339</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a5e837b6c4251c2fe69066d3146dd8478"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetLastMovingPosition </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inLastPositionIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the last position reached by this accessory. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inLastPositionIndex</td><td>last position reached by the accessory. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00157">157</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a1d8deba14ebc355146c2ff26b4e4669c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetNextAccessory </td>
          <td>(</td>
          <td class="paramtype">Accessory *&#160;</td>
          <td class="paramname"><em>inAccessory</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the next accessory in the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inAccessory</td><td>address of the next accessory in the list. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00350">350</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac5208f338b6ea9a5b5fd554c4e1ec60e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetStartingMillis </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Sets the starting time of a new action. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00441">441</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a408602468720dbf84c1e3d27cc0385da"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Accessory::SetState </td>
          <td>(</td>
          <td class="paramtype">ACC_STATE&#160;</td>
          <td class="paramname"><em>inNewState</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Change the state of the accessory. The accessory will physically move to reach the new state. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inNewState</td><td>new state to reach. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classAccessoryMotor.html#a3d013b0eaa9e9420bbd11d79529a474d">AccessoryMotor</a>, and <a class="el" href="classAccessoryLight.html#a93b9f956387afcae98f89391db0c2d6c">AccessoryLight</a>.</p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00430">430</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a60e5e9122c96773c975fe9d2c2db6520"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::SetStateRaw </td>
          <td>(</td>
          <td class="paramtype">ACC_STATE&#160;</td>
          <td class="paramname"><em>inNewState</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Change the state of the accessory. The accessory will NOT move to reach the new state. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inNewState</td><td>new state to reach. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00165">165</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ab1dad31ee3bcac4b1baf9a140c7fa57d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::StartAction </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Starts a new action. </p><dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00077">77</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a9a3c9f8604297fcb55141a720169fd90"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Accessory::StartAction </td>
          <td>(</td>
          <td class="paramtype">ACC_STATE&#160;</td>
          <td class="paramname"><em>inState</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Starts a new action and sets the current state of this accessory. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">inState</td><td>new current state of this accessory. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>Only for internal usage. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Accessory_8cpp_source.html#l00090">90</a> of file <a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a9f524a5ba6ba7f33e814e687c2912181"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual ACC_STATE Accessory::Toggle </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Basic function to toggle the accessory. A turnout will change its position, a light will change its state to on or off depending of its current state... </p><dl class="section return"><dt>Returns</dt><dd>new state of the accessory. </dd></dl>

<p>Implemented <a class="el" href="classAccessoryMotor.html#a6e200c4a8754830a3583a5abc7ed51fe">AccessoryMotor</a>, and <a class="el" href="classAccessoryLight.html#ab46a5519912b1589e24983b1789768eb">AccessoryLight</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="ae1ebffdf3fe753e3c5e7d05c2a61fd18"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPort.html">Port</a>* Accessory::pPort</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classPort.html">Port</a> to drive the accessory. An accessory should always have a port, even if this is the Arduino itself... </p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00167">167</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7079494cf9cb5130e5b3a5762e04e947"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ACC_STATE Accessory::prevState</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Previous state of the accessory. </p>

<p class="definition">Definition at line <a class="el" href="Accessory_8hpp_source.html#l00170">170</a> of file <a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="Accessory_8hpp_source.html">Accessory.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="Accessory_8cpp_source.html">Accessory.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classAccessory.html">Accessory</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
